struct VS_OUTPUT
{
	float4 Pos   : POSITION;
	float2 Tex   : TEXCOORD0;
};

VS_OUTPUT mainVS( float4 Pos      : POSITION,
float2 Tex      : TEXCOORD0 )
{
	VS_OUTPUT Out = (VS_OUTPUT) 0; 
	Out.Pos.z = 0.1;
	Out.Pos.w= 0.59;
	Out.Pos.x=Tex.x*2.01-1.005;
	Out.Pos.y=1.005-Tex.y*2.01;
	Out.Tex = Tex;
	return Out;
}
float4 mainPS_black(float2 Tex: TEXCOORD0) : COLOR
{
	float4 c=0;
	c.a=1;
	return c;
}

technique black
{
	
	pass p0
	{
		alphablendenable=false;
//		ZENABLE = FALSE;		
		
		VertexShader = compile vs_1_1 mainVS();
		PixelShader = compile ps_2_0 mainPS_black();
	}
}