path "F:\\GStudio_com_6.6\\template";	// Path to WDL templates subdirectory
path "F:\\GStudio_com_6.6\\template_6\\code";	
////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode =7;	 // screen size 640x480
var video_depth = 32; // 16 bit colour D3D mode

/////////////////////////////
// Variablen
//////////////////////////////
string level_str = <level.WMB>; // give file names in angular brackets
PLUGINDIR = "."; 


/********************************
** render2texture.dll          **
** you only need these 4 lines **
** have fun                    **
*********************************
** ChrisB, 2007                **
********************************/
dllfunction r2T_eventSky(); 
dllfunction r2T_eventEntities(); 
render_sky=r2T_eventSky;
render_entities=r2T_eventEntities;
//////////////////////////////////





BMAP* bloom1_bmap;
BMAP* bloom2_bmap;
BMAP* bloom3_bmap;
bmap* scene_bmap;
panel test_pan
{
	pos_x=0;
	flags=visible;
	size_x=1024;
	size_y=1024;
	scale_x=0.25;
	scale_y=0.25;
//	scale_x=0.26;//0.78;
//	scale_y=0.19;//0.5859;
}
panel bloom1_pan
{
	pos_y=200;
//	flags=visible;
	size_x=256;//1024;
	size_y=256;//1024;
	scale_x=0.5;
	scale_y=0.5;
//	scale_x=0.78;
//	scale_y=0.5859;
}
panel bloom2_pan
{
	pos_y=200;
	pos_x=128;
//	flags=visible;
	size_x=256;//1024;
	size_y=256;//1024;
	scale_x=0.5;
	scale_y=0.5;
//	scale_x=0.78;
//	scale_y=0.5859;
}
panel bloom3_pan
{
	pos_y=200;
	pos_x=256;
//	flags=visible;
	size_x=256;//1024;
	size_y=256;//1024;
	scale_x=0.5;
	scale_y=0.5;
//	scale_x=0.78;
//	scale_y=0.5859;
}

view bloomDownsample_view
{
	size_x=256;
	size_y=256;
	layer=-9;
	z=-250;
}
view camView
{
	size_x=800;
	size_y=600;
	layer=-10;
}
function bloomDownsample_event()
{
	if(render_view==bloomDownsample_view)
	{
		return(0);
	}
	return(1);
}
material bloomDownsample_mat
{
	effect="bloomDown.fx";
	event=bloomDownsample_event;
	flags=enable_tree;
}
entity* bloomDownsample_ent;/*
{
	type="render_512.tga";
	view=bloomDownsample_view;
	material=bloomDownsample_mat;
	flags=visible;
	layer=1;
}*/


function bloomBlack_event()
{
	if(render_view==camera || render_view==camView)
	{
		return(1);
	}
	return(0);
}
material bloomBlack_mat
{
	effect="bloomBlack.fx";
	event=bloomBlack_event;
	flags=enable_tree;
}
entity* bloomBlack_ent;
view bloomHBlur_view
{
	size_x=256;
	size_y=256;
	layer=-8;
	z=-250;
}
function bloomHBlur_event()
{
	if(render_view==bloomHBlur_view)
	{
		return(0);
	}
	return(1);
}
material bloomHBlur_mat
{
	effect="bloomH.fx";
	event=bloomHBlur_event;
	flags=enable_tree;
}
entity* bloomHBlur_ent;/*
{
	type="render_512.tga";
	view=bloomHBlur_view;
	material=bloomHBlur_mat;
	flags=visible;
	layer=2;
}*/

view bloomVBlur_view
{
	size_x=256;
	size_y=256;
	layer=-7;
	z=-250;
}
function bloomVBlur_event()
{
	if(render_view==bloomVBlur_view)
	{
		return(0);
	}
	return(1);
}
material bloomVBlur_mat
{
	effect="bloomV.fx";
	event=bloomVBlur_event;
	flags=enable_tree;
}
entity*  bloomVBlur_ent;/*
{
	type="render_512.tga";
	view=bloomHBlur_view;
	material=bloomVBlur_mat;
	flags=visible;
	layer=3;
}*/

material bloomFinal_mat
{
	effect="bloomFinal.fx";
}
entity bloomFinal_ent
{
	type="render_512.tga";
	material=bloomFinal_mat;
	flags=visible;
//	layeR=10;
}
include <mtlFX.wdl>;

material white
{
	emissive_Red=255;
	emissive_green=255;
	emissive_blue=255;
}
material white2
{
	emissive_Red=128;
	emissive_green=128;
	emissive_blue=128;
	ambient_red=0;
	ambient_green=0;
	ambient_blue=0;
	diffuse_red=0;
	diffuse_green=0;
	diffuse_blue=0;
}
sky cube2
{
	type="sky_gorge+6.bmp";
	layer=2;
	material=white2;
	flags=CUBE,VISIBLE;
}
////////////////////////////////////////////////////////////////
// The main() function is started at game start
var vSpeed[3];
var vForce[3];
var vMove[3];
var vAngularSpeed[3];

function main()
{
	level_load(level_str);
	camera.visible=0;
	wait(5);
	bloomDownsample_ent=ent_create("render_512.tga",vector(0,0,-200),0);
	bloomHBlur_ent=ent_create("render_512.tga",vector(0,0,-200),0);
	bloomVBlur_ent=ent_create("render_512.tga",vector(0,0,-200),0);
//	bloomBlack_ent=ent_create("render_512.tga",vector(-100,0,-200),0);
	bloomDownsample_ent.material=bloomDownsample_mat;
	bloomHBlur_ent.material=bloomHBlur_mat;
	bloomVBlur_ent.material=bloomVBlur_mat;
//	bloomBlack_ent.material=bloomBlack_mat;
	scene_bmap=bmap_createblack(800,600,32);
	camView.bmap=scene_bmap;

	camView.visible=1;
	
	bloom1_bmap=bmap_createblack(256,256,32);
	bloom2_bmap=bmap_createblack(256,256,32);
	bloom3_bmap=bmap_createblack(256,256,32);
	bloomDownsample_view.bmap=bloom1_bmap;
	bloomHBlur_view.bmap=bloom2_bmap;
	bloomVBlur_view.bmap=bloom3_bmap;
	bloomDownsample_view.clip_far=100;
	bloomDownsample_mat.skin1=scene_bmap;
	
	bloomHBlur_view.clip_far=100;	
	bloomVBlur_view.clip_far=100;
	bloomHBlur_mat.skin1=bloom1_bmap;
	bloomVBlur_mat.skin1=bloom2_bmap;
	bloomFinal_mat.skin1=bloom3_bmap;
	bloomFinal_mat.skin2=scene_bmap;
	
	bloom1_pan.bmap=bloom1_bmap;
	bloom2_pan.bmap=bloom2_bmap;
	bloom3_pan.bmap=bloom3_bmap;
	

	bloomDownsample_view.visible=1;
	bloomHBlur_view.visible=1;
	bloomVBlur_view.visible=1;
	test_pan.bmap=scene_bmap;
	wait(5);
	while(1)
	{
		camView.arc=camera.arc;
		vec_set(camView.x,camera.x);
		vec_set(camView.pan,camera.pan);
//		vec_set(bloomDownsample_ent.x,camera.x);
		vForce.x = -5*(mouse_force.x);	// pan angle
		vForce.y = 5*(mouse_force.y);	// tilt angle
		vForce.z = 0;	// roll angle
		vec_accelerate(vMove,vAngularSpeed,vForce,0.8);
		vec_add(camera.pan,vMove);		

		vForce.x = 6 * (key_w - key_s);		// forward
		vForce.y = 6 * (key_a - key_d);		// sideward
		vForce.z = 6 * (key_home -key_end);	// upward
		vec_accelerate(vMove,vSpeed,vForce,0.5);
		vec_rotate(vMove,camera.pan);
		vec_add(camera.x,vMove);
		wait(1);
	}
}

include "gui.wdl";
